/*****************************************************************************

		Copyright (c) My Company

 Project:  EXPERTSYSTEM
 FileName: EXPERTSYSTEM.PRO
 Purpose: No description
 Written by: Visual Prolog
 Comments:
******************************************************************************/

include "expertsystem.inc"
include "expertsystem.con"
include "hlptopic.con"

%BEGIN_WIN Task Window
/***************************************************************************
		Event handling for Task Window
***************************************************************************/

database - expertdb

  % transport description: name, list of property identificators
  transport(string, ilist)

  % properties counter
  single nprops(INTEGER)

  % property desc: id, name
  property(integer, string)

  temp1(string)
  temp2(string)

domains
  iilist = ilist*

predicates
  props2ids(slist, ilist)
  ids2props(ilist, slist)

  sfirst(slist, string)
  ifirst(ilist,integer)

  isInclude(slist,string)

  ask(slist)
	
  logic(slist,iilist)
  
  check(slist)
  
  my_concat(slist,string)

  task_win_eh : EHANDLER

clauses
  nprops(0).

  props2ids([],[]):- !.
  props2ids([Prop|SList], [Id|IList]):-
    retract(property(Id,Prop),expertdb),
    assert(property(Id,Prop),expertdb),
    props2ids(SList, IList), !.
    
  ids2props([],[]):- !.    
  ids2props([Id|IList],[Prop|SList]):-
    retract(property(Id, Prop),expertdb),
    assert(property(Id, Prop),expertdb),
    ids2props(IList, SList),
    !.

  sfirst([H|_], H):-!.
  ifirst([H|_], H):-!.
      
  isInclude([X|_], X):-!.
  isInclude([_|T], X):-
    isInclude(T, X).
  
  ask([]):- !.  
  ask([Prop|List]):-
    concat("Has this kind of transport got this property: \n", Prop,Text),
    Result=dlg_Ask(Text,["Yes", "No"]),
    Result=resp_default,
    assert(temp1(Prop),expertdb),
    ask(List),
    !.
  ask([_|List]):-
    ask(List),
    !.

  logic([],_):-!.
  logic([Transp|TList],[PropsId|PList]):-
    ids2props(PropsId,Props),
    check(Props),
    assert(temp2(Transp),expertdb),
    logic(TList,Plist),
    !.
  logic([_|List],[_|PList]):- 
    logic(List,PList),
    !.
  
  check([]):- !.
  check([Prop|List]):-
    temp1(Prop),
    check(List),
    !.

  my_concat([],""):-!.
  my_concat([X|List], Result):-
    my_concat(List,Text1),
    concat(X,"\n",Text2),
    concat(Text2,Text1,Result),!.
    
constants

%BEGIN Task Window, CreateParms, 23:20:16-28.9.2009, Code automatically updated!
  task_win_Flags = [wsf_SizeBorder,wsf_TitleBar,wsf_Close,wsf_Maximize,wsf_Minimize,wsf_ClipSiblings]
  task_win_Menu  = res_menu(idr_task_menu)
  task_win_Title = "ExpertSystem"
  task_win_Help  = idh_contents
%END Task Window, CreateParms

clauses

%BEGIN Task Window, e_Create
  task_win_eh(_Win,e_Create(_),0):-!,
%BEGIN Task Window, InitControls, 23:20:16-28.9.2009, Code automatically updated!
%END Task Window, InitControls
%BEGIN Task Window, ToolbarCreate, 23:20:16-28.9.2009, Code automatically updated!
%END Task Window, ToolbarCreate
ifdef use_message
	msg_Create(100),
enddef
	consult("expert.db", expertdb),
	!.
%END Task Window, e_Create

%MARK Task Window, new events

%BEGIN Task Window, id_menu_exit
  task_win_eh(_Win,e_Menu(id_menu_exit,_ShiftCtlAlt),0):-
  	win_Destroy(_Win),
	!.
%END Task Window, id_menu_exit

%BEGIN Task Window, id_menu_user
  task_win_eh(_Win,e_Menu(id_menu_user,_ShiftCtlAlt),0):-
	dlg_window_user_Create(_Win),
	!.
%END Task Window, id_menu_user

%BEGIN Task Window, id_menu_view_transport
  task_win_eh(_Win,e_Menu(id_menu_view_transport,_ShiftCtlAlt),0):-
	dlg_window_view_transport_Create(_Win),
	!.
%END Task Window, id_menu_view_transport

%BEGIN Task Window, id_menu_add_property_transport
  task_win_eh(_Win,e_Menu(id_menu_add_property_transport,_ShiftCtlAlt),0):-
  	dlg_window_add_transport_Create(_Win),
	!.
%END Task Window, id_menu_add_property_transport

%BEGIN Task Window, e_Destroy
  task_win_eh(_Win,e_Destroy,0):-
  	save("expert.db", expertdb),
	!.
%END Task Window, e_Destroy


%BEGIN Task Window, e_Size
  task_win_eh(_Win,e_Size(_Width,_Height),0):-!,
ifdef use_tbar
	toolbar_Resize(_Win),
enddef
ifdef use_message
	msg_Resize(_Win),
enddef
	!.
%END Task Window, e_Size

%END_WIN Task Window

/***************************************************************************
		Invoking on-line Help
***************************************************************************/

  project_ShowHelpContext(HelpTopic):-
  	vpi_ShowHelpContext("expertsystem.hlp",HelpTopic).

/***************************************************************************
			Main Goal
***************************************************************************/

goal

ifdef use_mdi
  vpi_SetAttrVal(attr_win_mdi,b_true),
enddef
ifdef ws_win
  ifdef use_3dctrl
    vpi_SetAttrVal(attr_win_3dcontrols,b_true),
  enddef
enddef  
  vpi_Init(task_win_Flags,task_win_eh,task_win_Menu,"expertsystem",task_win_Title).

%BEGIN_DLG About dialog
/**************************************************************************
	Creation and event handling for dialog: About dialog
**************************************************************************/

constants

%BEGIN About dialog, CreateParms, 23:20:16-28.9.2009, Code automatically updated!
  dlg_about_dialog_ResID = idd_dlg_about
  dlg_about_dialog_DlgType = wd_Modal
  dlg_about_dialog_Help = idh_contents
%END About dialog, CreateParms

predicates

  dlg_about_dialog_eh : EHANDLER

clauses

  dlg_about_dialog_Create(Parent):-
	win_CreateResDialog(Parent,dlg_about_dialog_DlgType,dlg_about_dialog_ResID,dlg_about_dialog_eh,0).

%BEGIN About dialog, idc_ok _CtlInfo
  dlg_about_dialog_eh(_Win,e_Control(idc_ok,_CtrlType,_CtrlWin,_CtrlInfo),0):-!,
	win_Destroy(_Win),
	!.
%END About dialog, idc_ok _CtlInfo
%MARK About dialog, new events

  dlg_about_dialog_eh(_,_,_):-!,fail.

%END_DLG About dialog

%BEGIN_DLG window_add_transport
/**************************************************************************
	Creation and event handling for dialog: window_add_transport
**************************************************************************/

constants

%BEGIN window_add_transport, CreateParms, 13:08:57-2.10.2009, Code automatically updated!
  dlg_window_add_transport_ResID = idd_window_add_transport
  dlg_window_add_transport_DlgType = wd_Modal
  dlg_window_add_transport_Help = idh_contents
%END window_add_transport, CreateParms

predicates

  dlg_window_add_transport_eh : EHANDLER
  dlg_window_add_transport_handle_answer(INTEGER EndButton,DIALOG_VAL_LIST)
  dlg_window_add_transport_update(DIALOG_VAL_LIST)

clauses

  dlg_window_add_transport_Create(Parent):-

%MARK window_add_transport, new variables

	dialog_CreateModal(Parent,dlg_window_add_transport_ResID,"",
  		[
%BEGIN window_add_transport, ControlList, 13:08:57-2.10.2009, Code automatically updated!
		df(idc_transport,editstr("",[]),nopr),
		df(idc_properties,listbox([],[0]),nopr),
		df(idc_chosen_properties,listbox([],[0]),nopr),
		df(idc_new_property,editstr("",[]),nopr)
%END window_add_transport, ControlList
		],
		dlg_window_add_transport_eh,0,VALLIST,ANSWER),
	dlg_window_add_transport_handle_answer(ANSWER,VALLIST).

  dlg_window_add_transport_handle_answer(idc_ok,VALLIST):-!,
	dlg_window_add_transport_update(VALLIST).
  dlg_window_add_transport_handle_answer(idc_cancel,_):-!.  % Handle Esc and Cancel here
  dlg_window_add_transport_handle_answer(_,_):-
	errorexit().

  dlg_window_add_transport_update(_VALLIST):-
%BEGIN window_add_transport, Update controls, 13:08:57-2.10.2009, Code automatically updated!
	_IDC_TRANSPORT_VALUE = dialog_VLGetstr(idc_transport,_VALLIST),
	dialog_VLGetListBox(idc_properties,_VALLIST,_IDC_PROPERTIES_ITEMLIST,_IDC_PROPERTIES_SELECT),
	dialog_VLGetListBox(idc_chosen_properties,_VALLIST,_IDC_CHOSEN_PROPERTIES_ITEMLIST,_IDC_CHOSEN_PROPERTIES_SELECT),
	_IDC_NEW_PROPERTY_VALUE = dialog_VLGetstr(idc_new_property,_VALLIST),
%END window_add_transport, Update controls
	true.

%MARK window_add_transport, new events

%BEGIN window_add_transport, idc_close _CtlInfo
  dlg_window_add_transport_eh(_Win,e_Control(idc_close,_CtrlType,_CtrlWin,_CtlInfo),0):-
  	win_Destroy(_Win),  	
	!.
%END window_add_transport, idc_close _CtlInfo

%BEGIN window_add_transport, e_Create
  dlg_window_add_transport_eh(_Win,e_Create(_CreationData),0):-
  	findall(X,property(_,X),PropList),
  	ListHandle=win_GetCtlHandle(_Win, idc_properties),
  	lbox_Add(ListHandle, 0, PropList),  
	!.
%END window_add_transport, e_Create

%BEGIN window_add_transport, idc_chosen_properties selchanged
  dlg_window_add_transport_eh(_Win,e_Control(idc_chosen_properties,_CtrlType,_CtrlWin,selchanged),0):-
  	% Get props ids
  	lbox_GetSel(_CtrlWin, _, IList),
  	% Get first amongst them
  	ifirst(IList, Index),  	
  	% remove from the list
  	lbox_Delete(_CtrlWin, Index),  	
	!.
%END window_add_transport, idc_chosen_properties selchanged

%BEGIN window_add_transport, idc_properties selchanged
  dlg_window_add_transport_eh(_Win,e_Control(idc_properties,_CtrlType,_CtrlWin,selchanged),0):-
  	% Get selected property
  	lbox_GetSel(_CtrlWin, PList, _),
  	sfirst(PList, Prop),
  	%dlg_note("meh"),
  	% Check whether it has already been chosen
  	HProps=win_GetCtlHandle(_Win, idc_chosen_properties),
  	Props=lbox_GetAll(HProps),
  	not(isInclude(Props,Prop)),
  	lbox_Add(HProps, 0, Prop),
	!.
  dlg_window_add_transport_eh(_Win,e_Control(idc_properties,_CtrlType,_CtrlWin,selchanged),0):-
  	dlg_error("This property has already been chosen."),
  	!.
  	
%END window_add_transport, idc_properties selchanged

%BEGIN window_add_transport, idc_add_transport _CtlInfo
  dlg_window_add_transport_eh(_Win,e_Control(idc_add_transport,_CtrlType,_CtrlWin,_CtlInfo),0):-
	HandleTransport=win_GetCtlHandle(_Win, idc_transport),
	Transport=win_GetText(HandleTransport),
	not(Transport=""),
	not(transport(Transport,_)),
	
	ListHandle=win_GetCtlHandle(_Win, idc_chosen_properties),
	PropsList=lbox_GetAll(ListHandle),
	
	% get properties ids list
	props2ids(PropsList,IdList),
	
	% add new transport to KB
	assert(transport(Transport,IdList)),
	!.
	
  dlg_window_add_transport_eh(_Win,e_Control(idc_add_transport,_CtrlType,_CtrlWin,_CtlInfo),0):-
  	dlg_error("Transport name is not entered or such a transport already exists in database"),
  	!.
	
%END window_add_transport, idc_add_transport _CtlInfo

%BEGIN window_add_transport, e_CloseRequest
  dlg_window_add_transport_eh(_Win,e_CloseRequest,0):-!,
	!.
%END window_add_transport, e_CloseRequest

%BEGIN window_add_transport, idc_add_property _CtlInfo
  dlg_window_add_transport_eh(_Win,e_Control(idc_add_property,_CtrlType,_CtrlWin,_CtlInfo),0):-
	HandleProp = win_GetCtlHandle(_Win, idc_new_property),
	Prop = win_GetText(HandleProp),
	not(Prop=""),
	not(property(_, Prop)),
	
	nProps(Id),
	Id2=Id+1,
	
	assert(nProps(Id2),expertdb),
	assert(property(Id, Prop)),

	HandlePropList1=win_GetCtlHandle(_Win, idc_properties),
	HandlePropList2=win_GetCtlHandle(_Win, idc_chosen_properties),
	lbox_Add(HandlePropList1, Prop),
	lbox_Add(HandlePropList2, Prop),
	!.
  dlg_window_add_transport_eh(_Win,e_Control(idc_add_property,_CtrlType,_CtrlWin,_CtlInfo),0):-
  	dlg_error("Property name is not entered or such a property already exists in database."),
  	!.
  	
%END window_add_transport, idc_add_property _CtlInfo

  dlg_window_add_transport_eh(_,_,_):-!,fail.

%END_DLG window_add_transport

%BEGIN_DLG window_view_transport
/**************************************************************************
	Creation and event handling for dialog: window_view_transport
**************************************************************************/

constants

%BEGIN window_view_transport, CreateParms, 17:01:31-29.9.2009, Code automatically updated!
  dlg_window_view_transport_ResID = idd_window_view_transport
  dlg_window_view_transport_DlgType = wd_Modal
  dlg_window_view_transport_Help = idh_contents
%END window_view_transport, CreateParms

predicates

  dlg_window_view_transport_eh : EHANDLER
  dlg_window_view_transport_handle_answer(INTEGER EndButton,DIALOG_VAL_LIST)
  dlg_window_view_transport_update(DIALOG_VAL_LIST)

clauses

  dlg_window_view_transport_Create(Parent):-

%MARK window_view_transport, new variables

	dialog_CreateModal(Parent,dlg_window_view_transport_ResID,"",
  		[
%BEGIN window_view_transport, ControlList, 17:01:31-29.9.2009, Code automatically updated!
		df(idc_transport,listbox([],[0]),nopr)
%END window_view_transport, ControlList
		],
		dlg_window_view_transport_eh,0,VALLIST,ANSWER),
	dlg_window_view_transport_handle_answer(ANSWER,VALLIST).

  dlg_window_view_transport_handle_answer(idc_ok,VALLIST):-!,
	dlg_window_view_transport_update(VALLIST).
  dlg_window_view_transport_handle_answer(idc_cancel,_):-!.  % Handle Esc and Cancel here
  dlg_window_view_transport_handle_answer(_,_):-
	errorexit().

  dlg_window_view_transport_update(_VALLIST):-
%BEGIN window_view_transport, Update controls, 17:01:31-29.9.2009, Code automatically updated!
	dialog_VLGetListBox(idc_transport,_VALLIST,_IDC_TRANSPORT_ITEMLIST,_IDC_TRANSPORT_SELECT),
%END window_view_transport, Update controls
	true.

%MARK window_view_transport, new events

%BEGIN window_view_transport, e_Create
  dlg_window_view_transport_eh(_Win,e_Create(_CreationData),0):-
  	findall(X,transport(X,_), TransportList),
  	HList = win_GetCtlHandle(_Win, idc_transport),
  	lbox_Add(HList, 0, TransportList),
	!.
%END window_view_transport, e_Create

%BEGIN window_view_transport, idc_close _CtlInfo
  dlg_window_view_transport_eh(_Win,e_Control(idc_close,_CtrlType,_CtrlWin,_CtlInfo),0):-
  	win_Destroy(_Win),  	
	!.
%END window_view_transport, idc_close _CtlInfo

%BEGIN window_view_transport, idc_delete_transport _CtlInfo
  dlg_window_view_transport_eh(_Win,e_Control(idc_delete_transport,_CtrlType,_CtrlWin,_CtlInfo),0):-
  	HList = win_GetCtlHandle(_Win, idc_transport),
  	lbox_GetSel(HList, SList, IList),
  	not(Slist=[]),
  	sfirst(SList, Transport),
  	ifirst(IList, Index),
  	retract(transport(Transport, _), expertdb),
  	lbox_Delete(HList, Index),
	!.
  dlg_window_view_transport_eh(_Win,e_Control(idc_delete_transport,_CtrlType,_CtrlWin,_CtlInfo),0):-
	dlg_error("Please choose any kind of transport"),
  	!.	
%END window_view_transport, idc_delete_transport _CtlInfo

%BEGIN window_view_transport, idc_view_properties _CtlInfo
  dlg_window_view_transport_eh(_Win,e_Control(idc_view_properties,_CtrlType,_CtrlWin,_CtlInfo),0):-
  	HList = win_GetCtlHandle(_Win, idc_transport),
  	lbox_GetSel(HList, SList, _),
  	not(Slist=[]),
  	dlg_windows_view_properties_Create(_Win),  	
	!.
%END window_view_transport, idc_view_properties _CtlInfo

  dlg_window_view_transport_eh(_,_,_):-!,fail.

%END_DLG window_view_transport

%BEGIN_DLG windows_view_properties
/**************************************************************************
	Creation and event handling for dialog: windows_view_properties
**************************************************************************/

constants

%BEGIN windows_view_properties, CreateParms, 12:57:37-1.10.2009, Code automatically updated!
  dlg_windows_view_properties_ResID = idd_windows_view_properties
  dlg_windows_view_properties_DlgType = wd_Modal
  dlg_windows_view_properties_Help = idh_contents
%END windows_view_properties, CreateParms

predicates

  dlg_windows_view_properties_eh : EHANDLER
  dlg_windows_view_properties_handle_answer(INTEGER EndButton,DIALOG_VAL_LIST)
  dlg_windows_view_properties_update(DIALOG_VAL_LIST)

clauses

  dlg_windows_view_properties_Create(Parent):-

%MARK windows_view_properties, new variables

	dialog_CreateModal(Parent,dlg_windows_view_properties_ResID,"",
  		[
%BEGIN windows_view_properties, ControlList, 12:57:37-1.10.2009, Code automatically updated!
		df(idc_properties,listbox([],[0]),nopr)
%END windows_view_properties, ControlList
		],
		dlg_windows_view_properties_eh,0,VALLIST,ANSWER),
	dlg_windows_view_properties_handle_answer(ANSWER,VALLIST).

  dlg_windows_view_properties_handle_answer(idc_ok,VALLIST):-!,
	dlg_windows_view_properties_update(VALLIST).
  dlg_windows_view_properties_handle_answer(idc_cancel,_):-!.  % Handle Esc and Cancel here
  dlg_windows_view_properties_handle_answer(_,_):-
	errorexit().

  dlg_windows_view_properties_update(_VALLIST):-
%BEGIN windows_view_properties, Update controls, 12:57:37-1.10.2009, Code automatically updated!
	dialog_VLGetListBox(idc_properties,_VALLIST,_IDC_PROPERTIES_ITEMLIST,_IDC_PROPERTIES_SELECT),
%END windows_view_properties, Update controls
	true.

%MARK windows_view_properties, new events

%BEGIN windows_view_properties, idc_close _CtlInfo
  dlg_windows_view_properties_eh(_Win,e_Control(idc_close,_CtrlType,_CtrlWin,_CtlInfo),0):-
  	win_Destroy(_Win),
	!.
%END windows_view_properties, idc_close _CtlInfo

%BEGIN windows_view_properties, e_Create
  dlg_windows_view_properties_eh(_Win,e_Create(_CreationData),0):-
  	_Parent=win_GetParent(_Win),
	HList=win_GetCtlHandle(_Parent,idc_transport),
	lbox_GetSel(HList, SList, _),
	sfirst(SList, Transport),
	retract(transport(Transport, Idents), expertdb),
	assert(transport(Transport, Idents), expertdb),
	ids2props(Idents, Props),
	HList2=win_GetCtlHandle(_Win,idc_properties),
	lbox_Add(HList2, 0, Props),
	
	!.
%END windows_view_properties, e_Create

  dlg_windows_view_properties_eh(_,_,_):-!,fail.

%END_DLG windows_view_properties

%BEGIN_DLG window_user
/**************************************************************************
	Creation and event handling for dialog: window_user
**************************************************************************/

constants

%BEGIN window_user, CreateParms, 22:36:42-1.10.2009, Code automatically updated!
  dlg_window_user_ResID = idd_window_user
  dlg_window_user_DlgType = wd_Modal
  dlg_window_user_Help = idh_contents
%END window_user, CreateParms

predicates

  dlg_window_user_eh : EHANDLER
  dlg_window_user_handle_answer(INTEGER EndButton,DIALOG_VAL_LIST)
  dlg_window_user_update(DIALOG_VAL_LIST)

clauses

  dlg_window_user_Create(Parent):-

%MARK window_user, new variables

	dialog_CreateModal(Parent,dlg_window_user_ResID,"",
  		[
%BEGIN window_user, ControlList, 22:36:42-1.10.2009, Code automatically updated!
		df(idc_transport,listbox([],[0]),nopr)
%END window_user, ControlList
		],
		dlg_window_user_eh,0,VALLIST,ANSWER),
	dlg_window_user_handle_answer(ANSWER,VALLIST).

  dlg_window_user_handle_answer(idc_ok,VALLIST):-!,
	dlg_window_user_update(VALLIST).
  dlg_window_user_handle_answer(idc_cancel,_):-!.  % Handle Esc and Cancel here
  dlg_window_user_handle_answer(_,_):-
	errorexit().

  dlg_window_user_update(_VALLIST):-
%BEGIN window_user, Update controls, 22:36:42-1.10.2009, Code automatically updated!
	dialog_VLGetListBox(idc_transport,_VALLIST,_IDC_TRANSPORT_ITEMLIST,_IDC_TRANSPORT_SELECT),
%END window_user, Update controls
	true.

%MARK window_user, new events

%BEGIN window_user, idc_close _CtlInfo
  dlg_window_user_eh(_Win,e_Control(idc_close,_CtrlType,_CtrlWin,_CtlInfo),0):-
  	win_Destroy(_Win),
	!.
%END window_user, idc_close _CtlInfo

%BEGIN window_user, idc_transport selchanged
  dlg_window_user_eh(_Win,e_Control(idc_transport,_CtrlType,_CtrlWin,selchanged),0):-
  	ListHandle=win_GetCtlHandle(_Win,idc_transport),
  	lbox_GetSel(ListHandle,SList,_),
  	sfirst(SList,Transport),
  	
  	retract(transport(Transport,IdProps),expertdb),
  	assert(transport(Transport,IdProps),expertdb),
  	
  	ids2props(IdProps,Props),
  	my_concat(Props,Text),
  	LabelHandle=win_GetCtlHandle(_Win,idct_explain),
  	concat("Transport is guessed based on following assumptions:\n",Text,ResultText),
  	win_SetText(LabelHandle,ResultText),
	!.
%END window_user, idc_transport selchanged

%BEGIN window_user, idc_answer_question _CtlInfo
  dlg_window_user_eh(_Win,e_Control(idc_answer_question,_CtrlType,_CtrlWin,_CtlInfo),0):-
  	retractall(temp1(_),expertdb),
  	retractall(temp2(_),expertdb),
  	findall(X,property(_,X),Props),
  	ask(Props),
  	findall(Y,transport(Y,_), Transport),
  	findall(Z,transport(_,Z), ListProps),
  	logic(Transport, ListProps),
  	findall(Y,temp2(Y), FoundTransport),
  	ListHandle=win_GetCtlHandle(_Win,idc_transport),
  	lbox_Clear(ListHandle),
  	lbox_Add(ListHandle, 0, FoundTransport),
  	!,
  	FoundTransport=[],
  	LabelHandle=win_GetCtlHandle(_Win, idct_explain),
  	win_SetText(LabelHandle, "No suitable transport found"),
	!.
%END window_user, idc_answer_question _CtlInfo

  dlg_window_user_eh(_,_,_):-!,fail.

%END_DLG window_user

